//+------------------------------------------------------------------+
//|                                    EA_OpenTime_TrndOPLmtTime.mq4 |
//+------------------------------------------------------------------+
#property copyright "20100907_1550"
#property link      ""

extern double dOpenTime  = 15.5; //15.5 means 15:30
extern double OrderStopHourMin  = 20.5;//20.5 means 20:30 
extern int breakpoint  = 4; 
extern int maxpoint  = 45; 
//extern int TP=50;
extern int mn=1;
extern double Lots=0.12;
extern bool   OptimizeLotSize=True;
extern bool   Anti_DrawDown=True;
extern double Risk=1;
extern double OrderLimit_Modulus=0.79;
extern int    OpenLimitTiming=60;
extern int    OpenLimitPnt_TrendOpen=5;
extern double StopLossPnt_TrendOpen=5;
extern double TakeProfit_Modulus=1.7;
extern double TrendOpen_SL_PerDst_Modulus=0.5;
extern double TrendOpen_TP_PerSL_Modulus=1.5;

double maxpeak,Equity,drawdownpercent,drawdown;
string OrdComment,MarketOrderCommentBuy="",MarketOrderCommentSell="";
int    LenOrdComment,LenMarketOrderComment;
string strDate,strDatePrev;
int    iStartHour,iOpenHour,iOpenMinute; 

int init(){
   OrdComment=StringConcatenate("EA_OpenTime_",DoubleToStr(iOpenHour,0));
   LenOrdComment=StringLen(OrdComment);
   maxpeak=AccountEquity();
   strDate=TimeToStr(TimeCurrent(),TIME_DATE);
   iOpenHour  = dOpenTime;
   iOpenMinute = (MathRound(dOpenTime-0.5)-MathRound(dOpenTime))*60; 
   iStartHour = iOpenHour-2;
   return(0);
}

int start()
  {
   OpenPattern();
   return(0);
  }

int day,buy,sell,stop;  
int OpenPattern()
{
   double op,sl,sl_small,tp,low,high,PriceDistance,TakeProfit,orderlimit,LotSize,PassedHighLow;
   int i,err;
   int iNowMinutes,iSessionEndPassedMinutes,HighestShift,LowestShift;
   datetime dtNow,Expiration;
   string OrderStopHour = DoubleToStr(MathRound(OrderStopHourMin-0.5),0);
   string OrderStopMinute = DoubleToStr((OrderStopHourMin-MathRound(OrderStopHourMin-0.5))*60,0);
   int iOrderStopMinutes  = StrToInteger(OrderStopHour)*60+StrToInteger(OrderStopMinute); 
   int iOpenTimeMinutes  = iOpenHour*60+iOpenMinute; 
   int iStartTimeMinutes  = iStartHour*60+iOpenMinute; 
   int iSessionOpenPeriodMinutes; 
   
   iSessionOpenPeriodMinutes=iOpenTimeMinutes-iStartTimeMinutes;
   iNowMinutes = Hour()*60+Minute();
   strDate=TimeToStr(TimeCurrent(),TIME_DATE);
   if(strDate!=strDatePrev){
//      Print("0 strDate=",strDate);
      strDatePrev=strDate;
   }

   if( iNowMinutes<iOrderStopMinutes && iNowMinutes>=iOpenTimeMinutes){ 
      buy=0;sell=0;
      for( i=0;i<OrdersTotal();i++){
         if (OrderSelect(i, SELECT_BY_TICKET, MODE_TRADES)){
            if ( StringSubstr(OrderComment(),0,LenOrdComment) == OrdComment ){ 
               if ( OrderType()==OP_BUY ){
                  buy++;
                  if(StringLen(MarketOrderCommentBuy)>0)
                     if(StringFind(OrderComment(),MarketOrderCommentBuy,0)>=0){
                        Print(" Buy market order executed.",MarketOrderCommentBuy);            
                        MarketOrderCommentBuy="";
                     }
               }
               if ( OrderType()==OP_SELL ){
                  sell++;
                  if(StringLen(MarketOrderCommentSell)>0)
                     if(StringFind(OrderComment(),MarketOrderCommentSell,0)>=0){
                        Print(" Sell market order executed.",MarketOrderCommentSell);            
                        MarketOrderCommentSell="";
                     }
               }
            }
         }
      }
//      if(buy>0||sell>0)Print("0 buy=",DoubleToStr(buy,0)," sell=",DoubleToStr(sell,0));            
      for( i=0;i<OrdersTotal();i++){
         if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)){
            // checking positions, if there are some opended orders
         
            if ( TimeHour(OrderExpiration())*60+TimeMinute(OrderExpiration())==iOrderStopMinutes){
               if ( OrderType()==OP_BUYSTOP ){
                  buy++;
               }
               if ( OrderType()==OP_SELLSTOP ){
                  sell++;
               }
            }
         }
      }

//      if(buy==0 && StringFind(MarketOrderCommentBuy,strDate,0)<0 || sell==0 && StringFind(MarketOrderCommentSell,strDate,0)<0){
      if(buy==0 || sell==0){
//      Print("0 strDate=",strDate," MarketOrderCommentBuy=",MarketOrderCommentBuy," MarketOrderCommentSell=",MarketOrderCommentSell,
//         " buy=",DoubleToStr(buy,0)," sell=",DoubleToStr(sell,0));
         iSessionEndPassedMinutes = iNowMinutes - iOpenTimeMinutes + 1 ;
         low= iLow(NULL,PERIOD_M1,iLowest(NULL, PERIOD_M1, MODE_LOW, iSessionOpenPeriodMinutes, iSessionEndPassedMinutes)); 
         high= iHigh(NULL,PERIOD_M1,iHighest(NULL, PERIOD_M1, MODE_HIGH, iSessionOpenPeriodMinutes, iSessionEndPassedMinutes)); 
      
         PriceDistance=MathAbs(high-low+breakpoint*Point*mn);
         orderlimit=PriceDistance*OrderLimit_Modulus;
         if(PriceDistance>=(maxpoint+2.0*breakpoint)*Point*mn || orderlimit<10*Point*mn)return(0);
      
   //      LotSize=MathRound((maxpoint-breakpoint)/(PriceDistance/Point/mn-10)*Lots*100.0)/100.0;
         if(OptimizeLotSize){
   //         LotSize=MathPow(AccountEquity(),0.7)/2000.0*Risk*(maxpoint+2.0*breakpoint)/(PriceDistance/Point/mn);
            LotSize=MathPow(AccountEquity(),0.7)*Risk/3500;
         }else LotSize=Lots;
         DrawDownCheck();
   //   Print(" drawdownpercent=",DoubleToStr(drawdownpercent,1));            
         if(Anti_DrawDown){
            if(drawdownpercent>0){LotSize=LotSize*13.0/(10.0+drawdownpercent);}
         }
         LotSize=NormalizeDouble(LotSize,2);
         if(LotSize<0.01){LotSize=0.01;}
         
//      Print("1 drawdownpercent=",DoubleToStr(drawdownpercent,1)," LotSize=",DoubleToStr(LotSize,2),
//         " low=",DoubleToStr(low,Digits)," high=",DoubleToStr(high,Digits)," buy=",DoubleToStr(buy,0)," sell=",DoubleToStr(sell,0));
               
         dtNow = TimeCurrent();
         Expiration=StrToTime(StringConcatenate(TimeToStr(dtNow,TIME_DATE)," ",OrderStopHour,":",OrderStopMinute));
   //   Print(" Expiration=",StringConcatenate(TimeToStr(dtNow,TIME_DATE)," ",OrderStopHour,":",OrderStopMinute));            
         TakeProfit=PriceDistance*TakeProfit_Modulus;
   //      if(TakeProfit/Point/mn > TP)TakeProfit=TP*Point*mn;
   //Print(" TakeProfit=",TakeProfit," Expiration=",TimeToStr(Expiration)," dtNow=",TimeToStr(dtNow, TIME_DATE));  
      }          
//      Print("1.4 StringFind(Nothing,txt,0)=",DoubleToStr(StringFind("",strDate,0),0));
      if(buy==0 && StringFind(MarketOrderCommentBuy,strDate,0)<0){
         PassedHighLow=iHigh(NULL,PERIOD_M1,iHighest(NULL, PERIOD_M1, MODE_HIGH,iSessionEndPassedMinutes,0));
//         Print("2 OpenTime_ZY - OP_BUYSTOP. MarketOrderCommentBuy=",MarketOrderCommentBuy,"  Ask=",DoubleToStr(Ask,Digits)," high=",DoubleToStr(high,Digits),
//            " Expiration=",TimeToStr(Expiration)," orderlimit=",DoubleToStr(orderlimit,Digits),
//            " PriceDistance=",DoubleToStr(PriceDistance,Digits)," PassedHighLow=",DoubleToStr(PassedHighLow,Digits));
         op=NormalizeDouble(high+breakpoint*Point*mn,Digits);  
//            sl=NormalizeDouble(high-StopLoss_Modulus*(high-low),Digits);
         sl=NormalizeDouble(low-Point,Digits);
         tp=NormalizeDouble(op+TakeProfit,Digits);
//         Print("2 OpenTime_ZY - OP_BUYSTOP.  Ask=",DoubleToStr(Ask,Digits)," op=",DoubleToStr(op,Digits)," sl=",DoubleToStr(sl,Digits),
//            " tp=",DoubleToStr(tp,Digits));
         if ( high + (Ask-Bid) -1*Point*mn > PassedHighLow) {
            if((op-Ask)>orderlimit){
   //Print(" Now to send a BUYSTOP order.");
//Print(" low=",DoubleToStr(low,Digits)," high=",DoubleToStr(high,Digits),
//" iSessionOpenPeriodMinutes=",DoubleToStr(iSessionOpenPeriodMinutes,0)," iSessionEndPassedMinutes=",DoubleToStr(iSessionEndPassedMinutes,0));            
               err=OrderSend(Symbol(),OP_BUYSTOP,LotSize,op,3,sl,tp,OrdComment,0,Expiration,Blue);
               if(err<0){Print("OpenTime_ZY - OP_BUYSTOP. MarketOrderCommentBuy="+MarketOrderCommentBuy+" op="+op+" sl="+sl+" tp="+tp+" Expiration="+TimeToStr(Expiration)+" Error="+GetLastError());return(-1);}
//Print("3 OpenTime_ZY - OP_BUYSTOP.  Ask=",DoubleToStr(Ask,Digits)," op=",DoubleToStr(op,Digits)," sl=",DoubleToStr(sl,Digits),
//   " tp=",DoubleToStr(tp,Digits));
               MarketOrderCommentBuy=StringConcatenate("_Buy_at_",strDate);
            }
         }else{
            //Trend Open
            HighestShift=iHighest(NULL, PERIOD_M1, MODE_LOW,iSessionEndPassedMinutes+120,0);
            LowestShift=iLowest(NULL, PERIOD_M1, MODE_LOW,iSessionEndPassedMinutes+120,0);
//            if(HighestShift<LowestShift && HighestShift <iSessionEndPassedMinutes+OpenLimitTiming && HighestShift >iSessionEndPassedMinutes)
            if(HighestShift <iSessionEndPassedMinutes+OpenLimitTiming && HighestShift >iSessionEndPassedMinutes)
               if((op-Ask)>OpenLimitPnt_TrendOpen*Point){
                  sl=NormalizeDouble(op-PriceDistance*TrendOpen_SL_PerDst_Modulus,Digits);
                  tp=NormalizeDouble(op+PriceDistance*TrendOpen_SL_PerDst_Modulus*TrendOpen_TP_PerSL_Modulus,Digits);
//Print(" low=",DoubleToStr(low,Digits)," high=",DoubleToStr(high,Digits),
//" iSessionOpenPeriodMinutes=",DoubleToStr(iSessionOpenPeriodMinutes,0)," iSessionEndPassedMinutes=",DoubleToStr(iSessionEndPassedMinutes,0));            
                  err=OrderSend(Symbol(),OP_BUYSTOP,LotSize,op,3,sl,tp,OrdComment,0,Expiration,Blue);
                  if(err<0){Print("OpenTime_ZY - OP_BUYSTOP. MarketOrderCommentBuy="+MarketOrderCommentBuy+" op="+op+" sl="+sl+" tp="+tp+" Expiration="+TimeToStr(Expiration)+" Error="+GetLastError());return(-1);}
//Print("4 OpenTime_ZY - OP_BUYSTOP.  Ask=",DoubleToStr(Ask,Digits)," op=",DoubleToStr(op,Digits)," sl=",DoubleToStr(sl,Digits),
//   " tp=",DoubleToStr(tp,Digits));
                  MarketOrderCommentBuy=StringConcatenate("_Buy_at_",strDate);
               }else if((op-Ask)<=0.2 && (op-Ask)>=-2){
   //Print(" Now to send a BUYSTOP order.");
//                  sl_small=op-StopLossPnt_TrendOpen*Point;
//                  sl_small=sl+PriceDistance/2.0;
                  sl=NormalizeDouble(Ask-PriceDistance*TrendOpen_SL_PerDst_Modulus,Digits);
                  tp=NormalizeDouble(Ask+PriceDistance*TrendOpen_SL_PerDst_Modulus*TrendOpen_TP_PerSL_Modulus,Digits);
                  MarketOrderCommentBuy=StringConcatenate("_Buy_at_",strDate);
//Print(" low=",DoubleToStr(low,Digits)," high=",DoubleToStr(high,Digits),
//" iSessionOpenPeriodMinutes=",DoubleToStr(iSessionOpenPeriodMinutes,0)," iSessionEndPassedMinutes=",DoubleToStr(iSessionEndPassedMinutes,0));            
                  err=OrderSend(Symbol(),OP_BUY,LotSize,Ask,3,sl,tp,StringConcatenate(OrdComment,MarketOrderCommentBuy),0,0,Blue);
                  if(err<0){Print("OpenTime_ZY - OP_BUY. op="+op+" sl_small="+sl_small+" tp="+tp+" Expiration="+TimeToStr(Expiration)+" Error="+GetLastError());return(-1);}
//Print("4 OpenTime_ZY - OP_BUY.  Ask=",DoubleToStr(Ask,Digits)," op=",DoubleToStr(op,Digits)," sl_small=",DoubleToStr(sl_small,Digits),
//   " tp=",DoubleToStr(tp,Digits));
               }
         }
      }
//      Print("1.5 StringFind(Nothing,txt,0)=",DoubleToStr(StringFind("",strDate,0),0));
      if(sell==0 && StringFind(MarketOrderCommentSell,strDate,0)<0){
         PassedHighLow=iLow(NULL,PERIOD_M1,iLowest(NULL, PERIOD_M1, MODE_LOW,iSessionEndPassedMinutes,0));
//         Print("2 OpenTime_ZY - OP_SELLSTOP. MarketOrderCommentSell=",MarketOrderCommentSell,"  Bid=",DoubleToStr(Bid,Digits)," low=",DoubleToStr(low,Digits),
//            " Expiration=",TimeToStr(Expiration)," orderlimit=",DoubleToStr(orderlimit,Digits),
//            " PriceDistance=",DoubleToStr(PriceDistance,Digits)," PassedHighLow=",DoubleToStr(PassedHighLow,Digits));
         op=NormalizeDouble(low-breakpoint*Point*mn,Digits);  
//            sl=NormalizeDouble(low+StopLoss_Modulus*(high-low),Digits);
         sl=NormalizeDouble(high+Point,Digits);
         tp=NormalizeDouble(low-TakeProfit,Digits);
//         Print("2 OpenTime_ZY - OP_SELLSTOP.  Bid=",DoubleToStr(Bid,Digits)," op=",DoubleToStr(op,Digits)," sl=",DoubleToStr(sl,Digits),
//            " tp=",DoubleToStr(tp,Digits));
         if ( low + 1*Point*mn<PassedHighLow ) {
//            op=low-breakpoint*Point*mn;  sl=high; tp=low-TakeProfit;
            if((Bid-op)>orderlimit){
   //Print(" Now to send a SELLSTOP order.");
//Print(" low=",DoubleToStr(low,Digits)," high=",DoubleToStr(high,Digits),
//" iSessionOpenPeriodMinutes=",DoubleToStr(iSessionOpenPeriodMinutes,0)," iSessionEndPassedMinutes=",DoubleToStr(iSessionEndPassedMinutes,0));            
               err=OrderSend(Symbol(),OP_SELLSTOP,LotSize,op,3,sl,tp,OrdComment,0,Expiration,Red);
               if(err<0){Print("OpenTime_ZY - OP_SELLSTOP. MarketOrderCommentSell="+MarketOrderCommentSell+" LotSize="+LotSize+" op="+op+" sl="+sl+" tp="+tp+" Expiration="+TimeToStr(Expiration)+" Error="+GetLastError());return(-1);}
//Print("3 OpenTime_ZY - OP_SELLSTOP.  Bid=",DoubleToStr(Bid,Digits)," op=",DoubleToStr(op,Digits)," sl=",DoubleToStr(sl,Digits),
//   " tp=",DoubleToStr(tp,Digits));
               MarketOrderCommentSell=StringConcatenate("_Sell_at_",strDate);
            }
         }else{
            //Trend Open
            HighestShift=iHighest(NULL, PERIOD_M1, MODE_LOW,iSessionEndPassedMinutes+120,0);
            LowestShift=iLowest(NULL, PERIOD_M1, MODE_LOW,iSessionEndPassedMinutes+120,0);
//            if(HighestShift>LowestShift && LowestShift<iSessionEndPassedMinutes+OpenLimitTiming && LowestShift>iSessionEndPassedMinutes)
            if(LowestShift<iSessionEndPassedMinutes+OpenLimitTiming && LowestShift>iSessionEndPassedMinutes)
               if((Bid-op)>OpenLimitPnt_TrendOpen*Point){
      //Print(" Now to send a SELLSTOP order.");
                  sl=NormalizeDouble(op+PriceDistance*TrendOpen_SL_PerDst_Modulus,Digits);
                  tp=NormalizeDouble(op-PriceDistance*TrendOpen_SL_PerDst_Modulus*TrendOpen_TP_PerSL_Modulus,Digits);
//Print(" low=",DoubleToStr(low,Digits)," high=",DoubleToStr(high,Digits),
//" iSessionOpenPeriodMinutes=",DoubleToStr(iSessionOpenPeriodMinutes,0)," iSessionEndPassedMinutes=",DoubleToStr(iSessionEndPassedMinutes,0));            
                  err=OrderSend(Symbol(),OP_SELLSTOP,LotSize,op,3,sl,tp,OrdComment,0,Expiration,Red);
                  if(err<0){Print("OpenTime_ZY - OP_SELLSTOP. MarketOrderCommentSell="+MarketOrderCommentSell+" op="+op+" sl="+sl+" tp="+tp+" Expiration="+TimeToStr(Expiration)+" Error="+GetLastError());return(-1);}
//Print("4 OpenTime_ZY - OP_SELLSTOP.  Bid=",DoubleToStr(Bid,Digits)," op=",DoubleToStr(op,Digits)," sl=",DoubleToStr(sl,Digits),
//   " tp=",DoubleToStr(tp,Digits));
                  MarketOrderCommentSell=StringConcatenate("_Sell_at_",strDate);
               }else if((Bid-op)<=0.2 && (Bid-op)>=-2){
   //Print(" Now to send a SELLSTOP order.");
//                  sl_small=op+StopLossPnt_TrendOpen*Point;
//                  sl_small=sl-PriceDistance/2.0;
                  sl=NormalizeDouble(Bid+PriceDistance*TrendOpen_SL_PerDst_Modulus,Digits);
                  tp=NormalizeDouble(Bid-PriceDistance*TrendOpen_SL_PerDst_Modulus*TrendOpen_TP_PerSL_Modulus,Digits);
                  MarketOrderCommentSell=StringConcatenate("_Sell_at_",strDate);
//Print(" low=",DoubleToStr(low,Digits)," high=",DoubleToStr(high,Digits),
//" iSessionOpenPeriodMinutes=",DoubleToStr(iSessionOpenPeriodMinutes,0)," iSessionEndPassedMinutes=",DoubleToStr(iSessionEndPassedMinutes,0));            
                  err=OrderSend(Symbol(),OP_SELL,LotSize,Bid,3,sl,tp,StringConcatenate(OrdComment,MarketOrderCommentBuy),0,0,Red);
                  if(err<0){Print("OpenTime_ZY - OP_SELL. op="+op+" sl_small="+sl_small+" tp="+tp+" Expiration="+TimeToStr(Expiration)+" Error="+GetLastError());return(-1);}
//Print("4 OpenTime_ZY - OP_SELL.  Bid=",DoubleToStr(Bid,Digits)," op=",DoubleToStr(op,Digits)," sl=",DoubleToStr(sl_small,Digits),
//   " tp=",DoubleToStr(tp,Digits));
               }
         }
      }
   }else{
      MarketOrderCommentBuy="";   
      MarketOrderCommentSell="";   
      if(day!=DayOfWeek()){_DeleteOrder(1);_DeleteOrder(0);}
   }
return(0);
}

int _DeleteOrder(int type)
{
   for( int i=1; i<=OrdersTotal(); i++)          
   {
    if(OrderSelect(i-1,SELECT_BY_POS)==true) 
    {                                       
     if(OrderType()==OP_SELLSTOP && StringFind(OrderComment(),OrdComment)>=0 && type==0)
     {
      OrderDelete(OrderTicket()); 
     }//if
  
    if(OrderType()==OP_BUYSTOP && StringFind(OrderComment(),OrdComment)>=0 && type==1)
     {
      OrderDelete(OrderTicket()); 
     }//if
    }//if
   }
   return(0);
}  

void DrawDownCheck(){
//---- drawdown check
   Equity=AccountEquity();
   if(maxpeak<AccountEquity()) maxpeak=AccountEquity();
   drawdown=maxpeak-Equity;
   if(maxpeak!=0.0)
     {
      drawdownpercent=drawdown/maxpeak*100.0;
     }
}

